<template>
  <v-navigation-drawer
    id="mobile-drawer"
    v-model="isMenuDrawerOpen"
    temporary
    fixed
    :class="[
      { 'dark-black-bg res-quarter-width': $vuetify.breakpoint.mdAndUp },
      'dark-black-bg res-width',
    ]"
    right
  >
    <div id="flex-wrapper">
      <div cols="12" class="text-right">
        <v-btn icon @click="closeMenuDrawer">
          <v-icon> mdi-close</v-icon>
        </v-btn>
      </div>

      <div id="mobile-drawer-menu" cols="12">
        <v-list dense nav>
          <v-text-field
            v-show="searchDrawer"
            v-model="filterSearch"
            class="mr-2 search-drawer"
            :placeholder="$t('common.search')"
            solo
            clearable
            @keyup.enter="submit"
          />
          <!-- PICK FOR ME BUTTON -->
          <v-btn
            class="
                                            mt-2
                                            ml-2
                                            mb-2
                                            lowercase
                                            br-0
                                            pa-6
                                            font-syne-bold
                                            br-15
                                        "
            color="badge"
            @click="goToMobilePage(menus.HOWPICKFORMEWORKS.id)"
          >
            {{ $t('buttons.pickForMeBtn') }}
          </v-btn>
          <v-list 
            class="py-0"
          >
            <v-list-group no-action :value="browseDropdown">
              <template v-slot:activator>
                <v-list-item-content>
                  <v-list-item-title>
                    {{ $t('appBar.browseStreetWear') }}
                  </v-list-item-title>
                </v-list-item-content>
              </template>

              <v-list-item
                link
                @click="goToPage(mobilemenus.BROWSESTREETWEAR.id)"
              >
                <v-list-item-content>
                  <v-list-item-title>
                    {{ $t('appBar.rent') }}
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
              <v-list-item
                link
                @click="goToPage(mobilemenus.SHOP.id)"
              >
                <v-list-item-content>
                  <v-list-item-title>
                    {{ $t('appBar.shop') }}
                  </v-list-item-title>
                </v-list-item-content>
              </v-list-item>
            </v-list-group>
          </v-list>

          <v-list-item
            link
            @click="goToPage(mobilemenus.HOWITWORKS.id)"
          >
            <v-list-item-content>
              <v-list-item-title>
                {{ $t('appBar.howItWorks') }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>

          <v-list-item
            link
            @click="goToPage(mobilemenus.PLANS.id)"
          >
            <v-list-item-content>
              <v-list-item-title>
                {{ $t('appBar.plans') }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>

          <v-list-item
            link
            @click="goToPage(mobilemenus.ABOUT.id)"
          >
            <v-list-item-content>
              <v-list-item-title>
                {{ $t('appBar.about') }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>

          <!-- <v-list-item
            v-for="(mm, mmenu) in mobilemenus"
            :key="'menuUnauth-' + mm.id"
            link
            @click="goToPage(mm.id)"
          >
            <v-list-item-content>
              <v-list-item-title>
                {{mm.id}}
                {{
                  $t('appBar.menu.' + mmenu)
                }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item> -->
        </v-list>

        <v-divider v-if="user.id !== 0" />
        <v-list v-if="user.id !== 0" dense nav>
          <v-list-item
            v-for="(m, menu) in menuDashboard"
            :key="'menuAuth-' + m.id"
            link
            @click="goToPage(m.id)"
          >
            <v-list-item-content>
              <v-list-item-title>
                {{
                  $t('dashboard.menu.' + menu)
                }}
              </v-list-item-title>
            </v-list-item-content>
          </v-list-item>
        </v-list>
      </div>
    </div>
  </v-navigation-drawer>
</template>

<script lang="ts">
import { Vue, Component } from 'vue-property-decorator'
import { mapGetters } from 'vuex'
const VueScrollTo = require('vue-scrollto')

@Component({
    computed: mapGetters({
        user: 'user/getUser',
        mobilemenus: 'menu/getMobileMenu',
        menus: 'menu/getMenu',
        menuDashboard: 'menu/getMenuDashboard',
        menuDrawer: 'drawerbar/getMenuDrawer',
    }),
})
export default class MenuDrawer extends Vue {
    // Data
    mobilemenus!: any
    menus!: any
    menuDashboard!: any
    menuDrawer!: boolean
    filterSearch: string = ''
    searchDrawer: Boolean = true
    browseDropdown: Boolean = false

    // Computed
    get isMenuDrawerOpen() {
        return this.menuDrawer
    }

    submit() {
        this.$store.commit('filter/setFilterSearchMutation', this.filterSearch)
        this.$router.push('/browse')
        this.closeMenuDrawer()
    }

    set isMenuDrawerOpen(value: boolean) {
        this.$store.commit('drawerbar/setMenuDrawer', value)
    }

    closeMenuDrawer() {
        this.$store.commit('drawerbar/setMenuDrawer', false)
    }

    // Methods
    goToMobilePage(id:Number) {
        switch (id) {
            case this.menus.HOWPICKFORMEWORKS.id:
                this.$router.push(this.menus.HOWPICKFORMEWORKS.path)
                break

            default:
                this.$router.push('/')
                break
        }
    }

    goToPage(id: Number) {
        switch (id) {
            case this.mobilemenus.BROWSESTREETWEAR.id:
                this.$router.push(this.mobilemenus.BROWSESTREETWEAR.path)
                this.browseDropdown = true
                break

            case this.mobilemenus.HOWITWORKS.id:
                VueScrollTo.scrollTo('.howitwork-section')
                this.closeMenuDrawer()
                this.$router.push(this.menus.HOME.path + '?scroll=howitworks')
                break

            case this.mobilemenus.PLANS.id:
                VueScrollTo.scrollTo('.plan-section')
                this.closeMenuDrawer()
                this.$router.push(this.menus.HOME.path + '?scroll=plans')
                break

            case this.mobilemenus.SHOP.id:
                this.$router.push(this.menus.SHOP.path)
                break

            case this.mobilemenus.ABOUT.id:
                this.$router.push(this.mobilemenus.ABOUT.path)
                break

            case this.menuDashboard.HOME.id:
                this.$router.push(this.menuDashboard.HOME.path)
                break

            case this.menuDashboard.PROFILE.id:
                this.$router.push(this.menuDashboard.PROFILE.path)
                break

            case this.menuDashboard.ADDRESS.id:
                this.$router.push(this.menuDashboard.ADDRESS.path)
                break

            case this.menuDashboard.ORDERS.id:
                this.$router.push(this.menuDashboard.ORDERS.path)
                break

            case this.menuDashboard.SUBSCRIPTION.id:
                this.$router.push(this.menuDashboard.SUBSCRIPTION.path)
                break

            case this.menuDashboard.PAYMENT.id:
                this.$router.push(this.menuDashboard.PAYMENT.path)
                break

            case this.menuDashboard.PAYMENT.sub.PAYMENTEDIT.id:
                this.$router.push(
                    this.menuDashboard.PAYMENT.sub.PAYMENTEDIT.path
                )
                break

            case this.menuDashboard.CHANGEPASSWORD.id:
                this.$router.push(this.menuDashboard.CHANGEPASSWORD.path)
                break

            case this.menuDashboard.SIGNOUT.id:
                this.logout()
                break

            default:
                this.$router.push('/')
                break
        }
    }

    logout() {
        // Remove token cookie
        this.$cookies.remove('t')

        // Remove order cookie
        this.$cookies.remove('o')

        // Remove secret cookie
        this.$cookies.remove('s')

        // Remove token from axios instance
        this.$axios.setToken(false)

        // Clear user profile
        this.$store.commit('user/clearUser')

        // Clear addresses
        this.$store.commit('user/clearAddresses')

        // Clear subscription
        this.$store.commit('subscription/clearSubscription')

        // Clear wishlist
        this.$store.commit('wishlist/clearWishlist')

        // Clear cart
        this.$store.commit('cart/clearCart')

        // Clear shop cart
        this.$store.commit('cart/clearCartShop')

        // Display snackbar
        const val = {
            text: this.$t('snackbar.logoutSuccess'),
            color: 'green',
            icon: 'mdi-check',
        }
        this.$store.dispatch('snackbar/displaySnackBar', val)

        // FB Logout
        // window.FB.logout()

        // Redirect
        this.$router.push('/')

        // Close menu drawer
        this.closeMenuDrawer()
    }
}
</script>
